=== debian/changelog ===
rsplib (3.2.4-0ubuntu2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:25:21 +0100

rsplib (3.2.4-0ubuntu1) focal; urgency=medium

  * New upstream version using Qt5. (LP: #1757859)
  * Merge upstream packaging.
  * Update symbols files following library soname bumps.

 -- Rik Mills <rikmills@kde.org>  Sun, 01 Dec 2019 10:16:06 +0000
