## rsplib 3.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 #
 # ------------- An Efficient RSerPool Prototype Implementation -------------
 #
-# Copyright (C) 2002-2019 by Thomas Dreibholz
+# Copyright (C) 2002-2022 by Thomas Dreibholz
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,12 +25,12 @@
 #
 # Contact: dreibh@iem.uni-due.de
 
-CMAKE_MINIMUM_REQUIRED(VERSION 3.0.2)
+CMAKE_MINIMUM_REQUIRED(VERSION 3.5.1)
 PROJECT(rsplib LANGUAGES C CXX)
 
 SET(BUILD_MAJOR "3")
-SET(BUILD_MINOR "2")
-SET(BUILD_PATCH "4")
+SET(BUILD_MINOR "4")
+SET(BUILD_PATCH "1")
 SET(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH})
 
 
@@ -65,34 +65,31 @@
 #############################################################################
 
 IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
-    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
-    ADD_DEFINITIONS("-D_DEFAULT_SOURCE -DLINUX")
+   MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
+   ADD_DEFINITIONS("-D_DEFAULT_SOURCE")
 
 ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
-    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
-    SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include")
-    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
-    INCLUDE_DIRECTORIES("/usr/local/include")
-    ADD_DEFINITIONS("-DFreeBSD")
+   MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
+   SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include")
+   SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
+   INCLUDE_DIRECTORIES("/usr/local/include")
+   SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
+   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
 
 ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
-    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
-    SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include" "/usr/local/opt/openssl/include")
-    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
-    INCLUDE_DIRECTORIES("/usr/local/include" "/usr/local/opt/openssl/include")
-    ADD_DEFINITIONS("-DDARWIN")
+   MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
+   SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include" "/usr/local/opt/openssl/include")
+   SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
+   INCLUDE_DIRECTORIES("/usr/local/include" "/usr/local/opt/openssl/include")
 
 ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
-    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
-    LIST(APPEND neat_headers neat_bsd.h)
-    LIST(APPEND neat_sources neat_bsd.c)
-    SET(CMAKE_REQUIRED_INCLUDES "/usr/pkg/include" "/usr/include" "/usr/local/include")
-    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
-    INCLUDE_DIRECTORIES("/usr/pkg/include" "/usr/local/include")
-    ADD_DEFINITIONS("-DNetBSD")
+   MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
+   SET(CMAKE_REQUIRED_INCLUDES "/usr/pkg/include" "/usr/include" "/usr/local/include")
+   SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
+   INCLUDE_DIRECTORIES("/usr/pkg/include" "/usr/local/include")
 
 ELSE()
-    MESSAGE(FATAL_ERROR ${CMAKE_SYSTEM_NAME} " not supported (yet?)")
+   MESSAGE(FATAL_ERROR ${CMAKE_SYSTEM_NAME} " not supported (yet?)")
 
 ENDIF()
 
@@ -129,14 +126,6 @@
 #############################################################################
 # CHECK OPTIONS
 #############################################################################
-
-# Debug build type as default
-IF (NOT CMAKE_BUILD_TYPE)
-   MESSAGE(STATUS "No build type selected, using DEBUG")
-   SET(CMAKE_BUILD_TYPE "DEBUG")
-   # _FORTIFY_SOURCE requires compiling with optimization
-   SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O")
-ENDIF()
 
 # Maximum logging level
 SET(MAX_LOGLEVEL "9" CACHE STRING "Maximum logging level")
@@ -177,6 +166,12 @@
 #############################################################################
 # REQUIREMENTS
 #############################################################################
+
+# ###### Valgrind ###########################################################
+CHECK_INCLUDE_FILE("valgrind/memcheck.h" HAVE_VALGRIND_MEMCHECK_H)
+IF(HAVE_VALGRIND_MEMCHECK_H)
+   ADD_DEFINITIONS(-DHAVE_VALGRIND_MEMCHECK_H)
+ENDIF()
 
 # ###### Threads ############################################################
 FIND_PACKAGE(Threads REQUIRED)
@@ -238,27 +233,37 @@
 
 # ====== Functions ==========================================================
 INCLUDE(CheckFunctionExists)
-
-check_function_exists(sctp_send HAVE_SCTP_SEND)
+INCLUDE(CheckSymbolExists)
+
+CHECK_FUNCTION_EXISTS(sctp_send HAVE_SCTP_SEND)
 IF (HAVE_SCTP_SEND)
    ADD_DEFINITIONS(-DHAVE_SCTP_SEND)
 ENDIF()
 
-check_function_exists(sctp_sendx HAVE_SCTP_SENDX)
+CHECK_FUNCTION_EXISTS(sctp_sendx HAVE_SCTP_SENDX)
 IF (HAVE_SCTP_SENDX)
    ADD_DEFINITIONS(-DHAVE_SCTP_SENDX)
 ENDIF()
 
-check_function_exists(sctp_sendmsg  HAVE_SCTP_SENDMSG)
+CHECK_FUNCTION_EXISTS(sctp_sendmsg HAVE_SCTP_SENDMSG)
 IF (HAVE_SCTP_SENDMSG)
    ADD_DEFINITIONS(-DHAVE_SCTP_SENDMSG)
 ENDIF()
 
-check_function_exists(sctp_connectx HAVE_SCTP_CONNECTX)
+CHECK_FUNCTION_EXISTS(sctp_connectx HAVE_SCTP_CONNECTX)
 IF (HAVE_SCTP_CONNECTX)
    ADD_DEFINITIONS(-DHAVE_SCTP_CONNECTX)
 ENDIF()
 
+IF (USE_KERNEL_SCTP)
+   CHECK_SYMBOL_EXISTS(SCTP_DELAYED_SACK "netinet/sctp.h" HAVE_SCTP_DELAYED_SACK)
+ELSE()
+   CHECK_SYMBOL_EXISTS(SCTP_DELAYED_SACK "sctp.h" HAVE_SCTP_DELAYED_SACK)
+ENDIF()
+IF (HAVE_SCTP_DELAYED_SACK)
+   ADD_DEFINITIONS(-DHAVE_SCTP_DELAYED_SACK)
+ENDIF()
+
 
 # ###### BZip2 ##############################################################
 FIND_PACKAGE(BZip2 REQUIRED)
@@ -266,7 +271,7 @@
 
 # ###### IEEE Floating-Point ################################################
 INCLUDE(CheckCSourceRuns)
-check_c_source_runs("
+CHECK_C_SOURCE_RUNS("
 #include <stdio.h>
 
 union DoubleIntUnion
@@ -316,6 +321,14 @@
 SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall")
 SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
 
+MESSAGE("Architecture: ${CMAKE_SYSTEM_PROCESSOR}")
+IF( (CMAKE_SYSTEM_PROCESSOR MATCHES "^riscv64") OR
+    (CMAKE_SYSTEM_PROCESSOR MATCHES "^mips$")   OR
+    (CMAKE_SYSTEM_PROCESSOR MATCHES "^arm") )
+  STRING(APPEND CMAKE_C_STANDARD_LIBRARIES " -latomic")
+  STRING(APPEND CMAKE_CXX_STANDARD_LIBRARIES " -latomic")
+ENDIF()
+
 
 #############################################################################
 # SOURCE DIRECTORIES
