=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: rsplib
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Thomas Dreibholz <dreibh@iem.uni-due.de>
+Maintainer: Thomas Dreibholz <dreibh@iem.uni-due.de>
 Homepage: https://www.uni-due.de/~be0001/rserpool/
-Build-Depends: cmake (>= 3.0.2) | cmake3,
-               debhelper (>= 9),
+Build-Depends: cmake (>= 3.0.2),
+               debhelper-compat (= 13),
                dpkg-dev (>= 1.16.1~),
                libbz2-dev (>= 1.0),
                libfile-fcntllock-perl,
@@ -14,7 +13,10 @@
                qtbase5-dev,
                qtbase5-dev-tools,
                qtchooser
-Standards-Version: 4.4.0.1
+Standards-Version: 4.6.0.1
+Rules-Requires-Root: no
+Vcs-Git: https://github.com/dreibh/rsplib.git
+Vcs-Browser: https://github.com/dreibh/rsplib
 
 Package: librsplib3
 Section: libs
@@ -34,8 +36,7 @@
 Section: libdevel
 Architecture: any
 Depends: librsplib3 (= ${binary:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends}
+         ${misc:Depends}
 Recommends: rsplib-doc (>= ${source:Version})
 Description: headers of the RSerPool client/server API library rsplib
  Reliable Server Pooling (RSerPool) is the IETF's standard (RFC 5351 to
@@ -67,8 +68,7 @@
 Architecture: any
 Depends: libcpprspserver3 (= ${binary:Version}),
          librsplib-dev (>= ${source:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends}
+         ${misc:Depends}
 Recommends: rsplib-doc (>= ${source:Version})
 Description: headers of the C++ RSerPool client/server API library
  Reliable Server Pooling (RSerPool) is the IETF's standard (RFC 5351 to
